<?php
namespace Geral\Entities;

use Geral\Util\DateUtil;
use Setforms2\Shared\ORM\DateTime;
use Setforms2\Shared\Registry;
use Geral\Util\Ambiente;

class Servclie extends Base\Servclie
{
    /**
     * @param $linhas
     * @param $cdservfili
     *
     * @return null
     * @throws \Exception
     */
    public static function saveClientePorservico($linhas, $cdservfili)
    {
        $connection = Registry::getEntityManager();
        $connection->beginTransaction();

        $nrorg = Ambiente::getNrorg();
        foreach ($linhas as $registro) {
            $dtservfatu = $registro['DTSERVFATU'];
            $tam = strlen($dtservfatu);
            if($tam != 10) {
                $dtservfatu = explode(' ', $dtservfatu);
                $registro['DTSERVFATU'] = $dtservfatu[0];
            }

            $registro['DTSERVFATU'] = DateUtil::getDataDeString($registro['DTSERVFATU'], 'd/m/Y', true);
            if (empty($registro['CDSERVFILI'])) {
                $registro['CDSERVFILI'] = $cdservfili;
            }
            /**
             * @var \Geral\Entities\Servclie $servclie
             */
            $servclie = Servclie::getObjectByWhere(
                'CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ?  AND CDCLIENTE = ?',
                array(
                    $registro['CDFILIAL'], $nrorg, $registro['CDSERVFILI'],
                    $registro['CDCLIENTE']
                )
            );



            if (empty($servclie)) {
                $servclie = new Servclie();
                $servclie->setCdfilial($registro['CDFILIAL']);
                $servclie->setCdservfili($registro['CDSERVFILI']);
                $servclie->setCdcliente($registro['CDCLIENTE']);
            }
            $servclie->setVrservfatu($registro['VRSERVFATU']);
            $servclie->setQtefetmini($registro['QTEFETMINI']);
            $servclie->setQtvolproservcli($registro['QTVOLPROSERVCLI']);
            $servclie->setDtservfatu($registro['DTSERVFATU']);
            $servclie->setIdvrprfixaut($registro['IDVRPRFIXAUT']);
            $servclie->setDsemissercli($registro['DSEMISSERCLI']);
            $servclie->setIdativatabcor($registro['IDATIVATABCOR']);

            $servclie->setDtinclusao(DateUtil::getDataAtual());
            $servclie->setDtultatu(DateUtil::getDataAtual());
            $servclie->setNrorg($nrorg);
            $servclie->setNrorginclusao(Ambiente::getNrorg());
            $servclie->setCdoperinclusao(Ambiente::getCdOperador());
            $servclie->setNrorgultatu(Ambiente::getNrorg());
            $servclie->setCdoperultatu(Ambiente::getCdOperador());
            $servclie->persist();


        }
        $connection->flush();
        $connection->commit();
    }

    /**
     * @param $linhas
     * @param $data
     * @param $valor
     *
     * @return null
     * @throws \Exception
     */
    public static function atualizaExcessaoPorDia($linhas, $data, $valor)
    {
        try {
            $connection = Registry::getEntityManager();
            $connection->beginTransaction();
            foreach ($linhas as $registro) {

                $nrorg = Ambiente::getNrorg();
                $dataAtual = DateUtil::getDataAtual();
                $data = DateUtil::getDataDeString($data);

                if ($registro['VALORSERVICO'] < 0) {
                    tk_abort(tk_get_message_by_name('msg_fai00600_valor_maior_Zero'), 'error');
                }
                /**
                 * @var \Geral\Entities\Servclie $servclie
                 */
                $servclie = Servclie::getObjectByWhere(
                    'CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ?  AND CDCLIENTE = ?',
                    array(
                        $registro['CDFILIAL'], $nrorg, $registro['CDSERVFILI'],
                        $registro['CDCLIENTE']
                    )
                );


                $servclie->setCdfilial($registro['CDFILIAL']);
                $servclie->setCdservfili($registro['CDSERVFILI']);
                $servclie->setCdcliente($registro['CDCLIENTE']);
                $servclie->setVrservfatu($valor);
                $servclie->setDtservfatu($data);

                switch ($registro['DIASEMANA']) {
                case 'DOMINGO':
                    $servclie->setVrservfatdom($registro['VALORSERVICO']);
                    $servclie->setDsprodemisdom($registro['DESCSERVICO']);
                    break;
                case 'SEGUNDA':
                    $servclie->setVrservfatseg($registro['VALORSERVICO']);
                    $servclie->setDsprodemisseg($registro['DESCSERVICO']);
                    break;
                case 'TERÇA':
                    $servclie->setVrservfatter($registro['VALORSERVICO']);
                    $servclie->setDsprodemister($registro['DESCSERVICO']);
                    break;
                case 'QUARTA':
                    $servclie->setVrservfatqua($registro['VALORSERVICO']);
                    $servclie->setDsprodemisqua($registro['DESCSERVICO']);
                    break;
                case 'QUINTA':
                    $servclie->setVrservfatqui($registro['VALORSERVICO']);
                    $servclie->setDsprodemisqui($registro['DESCSERVICO']);
                    break;
                case 'SEXTA':
                    $servclie->setVrservfatsex($registro['VALORSERVICO']);
                    $servclie->setDsprodemissex($registro['DESCSERVICO']);
                    break;
                case 'SÁBADO':
                    $servclie->setVrservfatsab($registro['VALORSERVICO']);
                    $servclie->setDsprodemissab($registro['DESCSERVICO']);
                    break;
                case 'FERIADO':
                    $servclie->setVrservfatfer($registro['VALORSERVICO']);
                    $servclie->setDsprodemisfer($registro['DESCSERVICO']);
                    break;
                }


                $servclie->setDtinclusao($dataAtual);
                $servclie->setDtultatu($dataAtual);
                $servclie->setNrorg($nrorg);
                $servclie->setNrorginclusao(Ambiente::getNrorg());
                $servclie->setCdoperinclusao(Ambiente::getCdOperador());
                $servclie->setNrorgultatu(Ambiente::getNrorg());
                $servclie->setCdoperultatu(Ambiente::getCdOperador());
                $servclie->persist();


            }
            $connection->flush();
            $connection->commit();

            tk_message(tk_get_message_by_name('msg_gep_Atualizado'), 'success');
            tk_close_window('win_fai00600_CadastramentoValidade_pop_up', true);
            tk_reload_data_with_filter('tab_fai00600_003', 'win_fai00600');

        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * @param $cdfilial
     * @param $cdcliente
     * @param $cdservfili
     * @param $acrescimo
     * @param $cdproduto
     * @param $tipocusto
     *
     * @return bool.
     * @throws \Exception
     */
    public static function saveProdutoCliente(
        $cdfilial, $cdcliente, $cdservfili,
        $acrescimo, $cdproduto, $tipocusto
    )
    {
        try {
            $connection = Registry::getEntityManager();
            $connection->beginTransaction();

            $nrorg = Ambiente::getNrorg();
            $data = DateUtil::getDataAtual();

            if ($acrescimo>100 OR $acrescimo<0) {
                return false;
            }

            /**
             * @var \Geral\Entities\Servclie $servclie
             */
            $servclie = Servclie::getObjectByWhere(
                'CDFILIAL = ? AND NRORG = ? AND CDSERVFILI = ?  AND CDCLIENTE = ?',
                array($cdfilial, $nrorg, $cdservfili, $cdcliente)
            );

            $servclie->setVrtaxaprvar($acrescimo);
            $servclie->setCdproduto($cdproduto);
            $servclie->setIdtcusprvar($tipocusto);
            $servclie->setDtinclusao($data);
            $servclie->setDtultatu($data);
            $servclie->setNrorg($nrorg);
            $servclie->setNrorginclusao(Ambiente::getNrorg());
            $servclie->setCdoperinclusao(Ambiente::getCdOperador());
            $servclie->setNrorgultatu(Ambiente::getNrorg());
            $servclie->setCdoperultatu(Ambiente::getCdOperador());
            $servclie->persist();

            $connection->flush();
            $connection->commit();

        } catch (\Exception $e) {
            throw $e;
        }
        return true;
    }
}